<template>
    <div class="cg-container">
        <div class="row">
            <h4 class="cg-sub-heading pad-top-mdm second d-block font1 f20 text-center w700">Top Downloaded Products</h4>
        </div>
        <div class="row">
            <!-- :src="featured_product.cover_photo_path" -->
            <div class="col-md-4" v-for="most_downloaded_product in products_">
                <div class="cg-featured-item-wrap first-bg">
                    <a :href="most_downloaded_product.product_url" class="cg-featured-item-achor">
                        <img class="product-thumb img-fluid"  v-lazy="most_downloaded_product.cover_photo_path"  :alt="most_downloaded_product.name">
                    </a>
                    <div class="cg-card-text-wrap">
                        <a :href="most_downloaded_product.product_url">

                            <div class="cg-price-bubble justify-content-center align-items-center">
                                <h3 class="cg-product-price first w600 font1"><span v-if="most_downloaded_product.price">${{ most_downloaded_product.price }}</span><span v-if="!most_downloaded_product.price">Free</span></h3>
                            </div>
                            <h4 class="cg-product-name second font1 f100p w700 pad-top-sml pad-left-mdm">{{ most_downloaded_product.name | subStrName }}</h4>
                        </a>

                        <div class="cg-store-in-category">
                            <a :href="most_downloaded_product.author.profile_url">
                                <h6 class="cg-account-name f14 light-grey pad-left-mdm pad-btm-mdm">{{ most_downloaded_product.author.user_profile.store_name | subStrStore}}</h6>
                            </a>
                            <a>
                                <h6 class="cg-account-name f14 light-grey pad-left-mdm pad-btm-mdm">in </h6>
                            </a>

                            <a :href="most_downloaded_product.product_sub_category.product_sub_category_url">
                                <h6 class="cg-account-name f14 light-grey pad-left-mdm pad-btm-mdm">{{ most_downloaded_product.product_sub_category.name }}</h6>
                            </a>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="row browse_prod_btn-row">
<!--            <ShopPagination v-if="pagination.last_page > 1" :pagination="pagination" :offset="5" @paginate="fetchMostDownloaded()" ></ShopPagination>-->
            <a href="/all-items" class="ﬁrst theme-bg f14 w600 browse_prod_btn">Browse Products</a>
        </div>

    </div>
</template>

<script>
    import Preloader from '../components/Preloader.vue';
    import ShopPagination from '../components/ShopPagination.vue';
    export default {
        data() {
            return {
                products_:{},
                pagination: {
                    'current_page': 1
                },
            }
        },
        components:{
            ShopPagination,
            Preloader
        },
        methods:{
            loadJs(url, callback) {
                jQuery.ajax({
                    url: url,
                    dataType: 'script',
                    success: callback,
                    async: true
                });
            },
            preLoad: function(){
                // just open
                const close = this.$preloaders.open({
                    container: ".cg-container",
                    component:Preloader,
                    // cssClass: 'test' ,
                    "overlayStyle": {
                        "backgroundColor": "#fff",
                        "opacity": .1,
                    }

                });

                // and close. That's it.
                setTimeout(close, 1500);
            },
            fetchMostDownloaded() {

                axios.get('/get_most_downloaded?page=' + this.pagination.current_page)
                    .then(response => {
                        this.products_ = response.data.data.data;
                        this.pagination = response.data.pagination;
                        if(this.products_.length ){
                            this.isEmpty=false;
                        }else{
                            this.isEmpty=true;
                        }
                    })
                    .catch(error => {
                        console.log(error.response.data);
                    });
            },
        },
        filters: {

            subStrName: function(string)
            {
                if(string.length >26)
                {
                    return string.substring(0,23) + '...';
                }
                else
                {
                    return string.substring(0,26);
                }
            },

            subStrStore: function(string)
            {
                if(string.length >26)
                {
                    return string.substring(0,23) + '...';
                }
                else
                {
                    return string.substring(0,23);
                }
            }

        },
        mounted() {
            this.fetchMostDownloaded();
        }
    }
</script>
